       IDENTIFICATION DIVISION.
       PROGRAM-ID.    PRIMER.

      ************************************************************
      * PRIMER EJEMPLO, RECIBE DATOS DE UNA FORMA                *
      * Y LOS MUESTRA EN EL RESULTADO                            *
      ************************************************************

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.       IBM.
       OBJECT-COMPUTER.       IBM.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.

           COPY "COBLIB\HTML-OUT.SEL".

       DATA DIVISION.

       FILE SECTION.

       COPY "COBLIB\HTML-OUT.FD".


       WORKING-STORAGE SECTION.

       COPY "COBLIB\TEMPLATE.WSS".

      *<COBHTTPD-DATA PREFIX="LS-">
       01  WEB-DATA.
           02  FUNC                  PIC X(10).
           02  CLAVE                 PIC X(10).
           02  NOMBRE                PIC X(50).
           02  DIRECCION             PIC X(50).
           02  IMPORTE               PIC 9(12)V99-.
           02  HTTP-HOST             PIC X(50).
           02  HTTP-SERVER-ADDR      PIC X(20).
           02  HTTP-REMOTE-ADDR      PIC X(20).
           02  HTTP-USER-AGENT       PIC X(50).


       01  LIN-FUNC.
           02  FILLER                PIC X(20) VALUE
               "EL VALOR DE FUNC = ".
           02  WS-FUNC               PIC X(20).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-CLAVE.
           02  FILLER                PIC X(20) VALUE
               "EL VALOR DE CLAVE = ".
           02  WS-CLAVE              PIC X(10).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-NOMBRE.
           02  FILLER                PIC X(25) VALUE
               "EL VALOR DE NOMBRE = ".
           02  WS-NOMBRE             PIC X(50).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-DIRECCION.
           02  FILLER                PIC X(25) VALUE
               "EL VALOR DE DIRECCION = ".
           02  WS-DIRECCION          PIC X(50).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-IMPORTE.
           02  FILLER                PIC X(25) VALUE
               "EL VALOR DE IMPORTE = ".
           02  WS-IMPORTE            PIC ZZZ,ZZZ,ZZ9.99-.
           02 FILLER                 PIC X(04) VALUE "<BR>".
           
           
       01  LIN-MSG1.
           02 FILLER      PIC X(100) VALUE
              "<BR>VARIABLES DEL SERVIDOR <BR>".
           
       01  LIN-HTTP-HOST.
           02  FILLER                PIC X(25) VALUE
               "EL VALOR DE HTTP-HOST = ".
           02  WS-HTTP-HOST          PIC X(50).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-HTTP-SERVER-ADDR.
           02  FILLER                PIC X(35) VALUE
               "EL VALOR DE HTTP-SERVER-ADDR = ".
           02  WS-HTTP-SERVER-ADDR   PIC X(20).
           02 FILLER                 PIC X(04) VALUE "<BR>".
           
       01  LIN-HTTP-REMOTE-ADDR.
           02  FILLER                PIC X(35) VALUE
               "EL VALOR DE HTTP-REMOTE-ADDR = ".
           02  WS-HTTP-REMOTE-ADDR   PIC X(20).
           02 FILLER                 PIC X(04) VALUE "<BR>".
           
       01  LIN-HTTP-USER-AGENT.
           02  FILLER                PIC X(35) VALUE
               "EL VALOR DE HTTP-USER-AGENT = ".
           02  WS-HTTP-USER-AGENT    PIC X(50).
           02 FILLER                 PIC X(04) VALUE "<BR>".



       LINKAGE SECTION.

       COPY "COBLIB\LS-HTTP.FDT".

       PROCEDURE DIVISION USING HTTP-CONTROL HTTP-DATA-INP.
       DECLARATIVES.
       BLOQUEO SECTION.
           USE AFTER STANDARD ERROR PROCEDURE ON HTML-OUT.
       END DECLARATIVES.
       PROGRAMA SECTION.
       0000-START.
           MOVE HTTP-DATA-INP  TO WEB-DATA.

           PERFORM TPL-OPEN-FILE.
           
           IF FUNC = "FORMA"
              PERFORM 100-SHOW-FORMA.
              
           IF FUNC = "GRABAR"
              PERFORM 200-GRABAR.


           CLOSE HTML-OUT.

           GO TO 999-EXIT.
           
       100-SHOW-FORMA.
           MOVE "tpl\primer.html" TO TPL-FILENAME.
           PERFORM TPL-ADD-FILENAME.
       
      * MUESTRA LOS DATOS QUE RECIBIO EL PROGRAMA
      * CON ESTOS DATOS PODEMOS HACER LO QUE DESEEMOS, GRABARLOS
      * EN UN ARCHIVO, VALIDAR, ETC.
      * INCLUSO PODEMOS ENVIARLOS A OTRO TEMPLATE
       200-GRABAR.
           MOVE FUNC TO WS-FUNC.
           MOVE CLAVE TO WS-CLAVE.
           MOVE NOMBRE TO WS-NOMBRE.
           MOVE DIRECCION TO WS-DIRECCION.
           MOVE IMPORTE   TO WS-IMPORTE.


           WRITE R-HTML-OUT FROM LIN-FUNC.
           WRITE R-HTML-OUT FROM LIN-CLAVE.
           WRITE R-HTML-OUT FROM LIN-NOMBRE.
           WRITE R-HTML-OUT FROM LIN-DIRECCION.
           WRITE R-HTML-OUT FROM LIN-IMPORTE.

           MOVE HTTP-HOST        TO WS-HTTP-HOST.
           MOVE HTTP-SERVER-ADDR TO WS-HTTP-SERVER-ADDR.
           MOVE HTTP-REMOTE-ADDR TO WS-HTTP-REMOTE-ADDR.
           MOVE HTTP-USER-AGENT  TO WS-HTTP-USER-AGENT.           
           WRITE R-HTML-OUT FROM LIN-MSG1.
           WRITE R-HTML-OUT FROM LIN-HTTP-HOST.
           WRITE R-HTML-OUT FROM LIN-HTTP-SERVER-ADDR.
           WRITE R-HTML-OUT FROM LIN-HTTP-REMOTE-ADDR.
           WRITE R-HTML-OUT FROM LIN-HTTP-USER-AGENT.


       COPY "COBLIB\TEMPLATE.FDT".

       999-EXIT.

       EXIT-PROG.
           EXIT PROGRAM.

       END PROGRAM.

